/* Release 3.00 */
/*-------------------------------------------------------------------------*
*                                                                          *
*  inline.h -  inline function definitions                                 *
*                                                                          *
*  COPYRIGHT (C) 1989..1991 Jensen and Partners. All Rights Reserved       *
*                                                                          *
*--------------------------------------------------------------------------*/

// CARL - The INLINE functions do NOT work in 32-bit so in case this file get's included use the library functions

#ifndef _INLINE_DEF
#define _INLINE_DEF

#ifdef __cplusplus
extern "C" {
#endif
int     memcmp(const void *_s1, const void *_s2, size_t _n);
void *  memcpy(void *_dest, const void *_source, size_t _n);
void *  memset(void *_s, int _c, size_t _n);
char *  strcat(char *_dest, const char *_source);
int     strcmp(const char *_s1, const char *_s2);
char *  strcpy(char *_dest, const char *_source);
size_t  strlen(const char *_s);
char *  strset(char *_s, int _ch);
#ifdef __cplusplus
}
#endif

#endif


/* CARL - skip INLINE

#ifndef _INLINE_DEF
#define _INLINE_DEF
#ifdef __cplusplus
extern "C" {
#endif

#pragma save

#ifndef _fcall
#define RET 0xC3
#else
#define RET 0xCB
#endif

#ifdef _fptr

#pragma call(reg_param=>(es,di,ax,cx),reg_saved=>(bx,si,ds,st1,st2), inline=>on)
static void *memset(void *_dest, int _ch, size_t _num)=
{
    0x8B, 0xD7,
    0x8A, 0xE0,
    0xE3, 0x10,
    0xF7, 0xC7, 0x01, 0x00,
    0x74, 0x02,
    0xAA,
    0x49,
    0xD1, 0xE9,
    0xF3, 0xAB,
    0x13, 0xC9,
    0xF3, 0xAA,
    0x8B, 0xC2,
    0x8C, 0xC2,
    RET
};

#pragma call(reg_param=>(es,di,si,dx,cx),reg_saved=>(ds,bx,st1,st2), inline=>on)
static void *memcpy(void *_dest, const void *_source, size_t _num)=
{
      0x1E,
      0x8E, 0xDA,
      0x8B, 0xD7,
      0xE3, 0x10,
      0xF7, 0xC7, 0x01, 0x00,
      0x74, 0x02,
      0xA4,
      0x49,
      0xD1, 0xE9,
      0xF3, 0xA5,
      0x13, 0xC9,
      0xF3, 0xA4,
      0x8B, 0xC2,
      0x8C, 0xC2,
      0x1F,
      RET
};

#pragma call(reg_param=>(si,dx,es,di,cx),reg_saved=>(ds,bx,st1,st2), inline=>on)
static int memcmp(const void *_dest, const void *_source, size_t _num)=
{
    0x1E,
    0x8E, 0xDA,
    0x2B, 0xC0,
    0xE3, 0x07,
    0xF3, 0xA6,
    0x74, 0x05,
    0x1B, 0xC0,
    0x1D, 0xFF, 0xFF,
    0x1F,
    RET
};

#pragma call(reg_param=>(es,di,si,dx),reg_saved=>(ds,bx,st1,st2), inline=>on)
static char *strcat(char *_dest, const char *_source)=
{
    0x1E,
    0x8E, 0xDA,
    0x8B, 0xD7,
    0xB9, 0xFF, 0xFF,
    0x33, 0xC0,
    0xF2, 0xAE,
    0x4F,
    0xAD,
    0x0A, 0xC0,
    0x74, 0x07,
    0xAB,
    0x0A, 0xE4,
    0xE0, 0xF6,
    0xEB, 0x01,
    0xAA,
    0x8B, 0xC2,
    0x8C, 0xC2,
    0x1F,
    RET
};

#pragma call(reg_param=>(si,dx,es,di),reg_saved=>(ds,bx,st1,st2), inline=>on)
static int   strcmp(const char *_s1, const char *_s2)=
{
    0x1E,
    0x8E, 0xDA,
    0x8B, 0xD7,
    0xB9, 0xFF, 0xFF,
    0x2B, 0xC0,
    0xF2, 0xAE,
    0xF7, 0xD1,
    0x8B, 0xFA,
    0xF3, 0xA6,
    0x74, 0x06,
    0x7C, 0x03,
    0x40,
    0xEB, 0x01,
    0x48,
    0x1F,
    RET
};

#pragma call(reg_param=>(ax,bx,cx,dx),reg_saved=>(ds,si,di,st1,st2), inline=>on)
static char *strcpy(char *_dest, const char *_source)=
{
    0x57,
    0x56,
    0x1E,
    0x8E, 0xC2,
    0x8B, 0xF9,
    0x8E, 0xDA,
    0x8B, 0xF1,
    0x8B, 0xD0,
    0xB9, 0xFF, 0xFF,
    0x2A, 0xC0,
    0xF2, 0xAE,
    0xF7, 0xD1,
    0x8E, 0xC3,
    0x8B, 0xFA,
    0xD1, 0xE9,
    0xF3, 0xA5,
    0x13, 0xC9,
    0xF3, 0xA4,
    0x8B, 0xC2,
    0x8C, 0xC2,
    0x1F,
    0x5E,
    0x5F,
    RET
};

#pragma call(reg_param=>(es,di),reg_saved=>(bx,si,ds,st1,st2), inline=>on)
static size_t strlen(const char *_s)=
{
    0xB9, 0xFF, 0xFF,
    0x2A, 0xC0,
    0xF2, 0xAE,
    0xF7, 0xD1,
    0x8B, 0xC1,
    0x48,
    RET
};

#pragma call(reg_param=>(es,di,bx),reg_saved=>(ds,si,st1,st2), inline=>on)
static char *strset(char *s, int _ch)=
{
    0x8B, 0xD7,
    0xB9, 0xFF, 0xFF,
    0x2A, 0xC0,
    0xF2, 0xAE,
    0xF7, 0xD1,
    0x49,
    0x8A, 0xC3,
    0x8A, 0xE0,
    0x8B, 0xFA,
    0xD1, 0xE9,
    0xF3, 0xAB,
    0x13, 0xC9,
    0xF3, 0xAA,
    0x8B, 0xC2,
    0x8C, 0xC2,
    RET
};
#else

#pragma call(reg_param=>(es,di,ax,cx),reg_saved=>(bx,si,ds,st1,st2), inline=>on)
static void *memset(void *_dest, int _ch, size_t _num)=
{
    0x1E, 0x07,
    0x8B, 0xD7,
    0x8A, 0xE0,
    0xE3, 0x10,
    0xF7, 0xC7, 0x01, 0x00,
    0x74, 0x02,
    0xAA,
    0x49,
    0xD1, 0xE9,
    0xF3, 0xAB,
    0x13, 0xC9,
    0xF3, 0xAA,
    0x8B, 0xC2,
    RET
};

#pragma call(reg_param=>(di,si,cx),reg_saved=>(bx,ds,st1,st2), inline=>on)
static void *memcpy(void *_dest, const void *_source, size_t _num)=
{
      0x1E, 0x07,
      0x8B, 0xD7,
      0xE3, 0x10,
      0xF7, 0xC7, 0x01, 0x00,
      0x74, 0x02,
      0xA4,
      0x49,
      0xD1, 0xE9,
      0xF3, 0xA5,
      0x13, 0xC9,
      0xF3, 0xA4,
      0x8B, 0xC2,
      RET
};

#pragma call(reg_param=>(si,di,cx),reg_saved=>(bx,ds,st1,st2), inline=>on)
static int memcmp(const void *_dest, const void *_source, size_t _num)=
{
    0x1E, 0x07,
    0x2B, 0xC0,
    0xE3, 0x07,
    0xF3, 0xA6,
    0x74, 0x05,
    0x1B, 0xC0,
    0x1D, 0xFF, 0xFF,
    RET
};

#pragma call(reg_param=>(di,si),reg_saved=>(bx,ds,st1,st2), inline=>on)
static char *strcat(char *_dest, const char *_source)=
{
    0x1E, 0x07,
    0x8B, 0xD7,
    0xB9, 0xFF, 0xFF,
    0x33, 0xC0,
    0xF2, 0xAE,
    0x4F,
    0xAD,
    0x0A, 0xC0,
    0x74, 0x07,
    0xAB,
    0x0A, 0xE4,
    0xE0, 0xF6,
    0xEB, 0x01,
    0xAA,
    0x8B, 0xC2,
    RET
};

#pragma call(reg_param=>(si,di),reg_saved=>(bx,ds,st1,st2), inline=>on)
static int   strcmp(const char *_s1, const char *_s2)=
{
    0x1E, 0x07,
    0x8B, 0xD7,
    0xB9, 0xFF, 0xFF,
    0x2B, 0xC0,
    0xF2, 0xAE,
    0xF7, 0xD1,
    0x8B, 0xFA,
    0xF3, 0xA6,
    0x74, 0x06,
    0x7C, 0x03,
    0x40,
    0xEB, 0x01,
    0x48,
    RET
};

#pragma call(reg_param=>(ax,bx,cx),reg_saved=>(ds,si,di,st1,st2), inline=>on)
static char *strcpy(char *_dest, const char *_source)=
{
    0x57,
    0x56,
    0x1E,
    0x07,
    0x8B, 0xFB,
    0x8B, 0xF3,
    0x8B, 0xD0,
    0xB9, 0xFF, 0xFF,
    0x2A, 0xC0,
    0xF2, 0xAE,
    0xF7, 0xD1,
    0x8B, 0xFA,
    0xD1, 0xE9,
    0xF3, 0xA5,
    0x13, 0xC9,
    0xF3, 0xA4,
    0x8B, 0xC2,
    0x5E,
    0x5F,
    RET
};

#pragma call(reg_param=>(es,di),reg_saved=>(bx,si,ds,st1,st2), inline=>on)
static size_t strlen(const char *_s)=
{
    0x1E, 0x07,
    0xB9, 0xFF, 0xFF,
    0x2A, 0xC0,
    0xF2, 0xAE,
    0xF7, 0xD1,
    0x8B, 0xC1,
    0x48,
    RET
};

#pragma call(reg_param=>(di,bx),reg_saved=>(ds,si,st1,st2), inline=>on)
static char *strset(char *_s, int _ch)=
{
    0x1E, 0x07,
    0x8B, 0xD7,
    0xB9, 0xFF, 0xFF,
    0x2A, 0xC0,
    0xF2, 0xAE,
    0xF7, 0xD1,
    0x49,
    0x8A, 0xC3,
    0x8A, 0xE0,
    0x8B, 0xFA,
    0xD1, 0xE9,
    0xF3, 0xAB,
    0x13, 0xC9,
    0xF3, 0xAA,
    0x8B, 0xC2,
    RET
};

#endif

#pragma restore
#ifdef __cplusplus
}
#endif

#endif

INLINE do not work in 32-bit */
