!ABCIncludeFile
!========================================
! Copyright  2005 by Carl Barnes
!========================================


 OMIT('_EndOfInclude_',_CBRC4_)
_CBRC4_ EQUATE(1)

!=======================================================================
! CBAffinityClass
!=======================================================================

!All work is done by Constructor so that the Affinity can be set as early as possible.

CBRC4Cls          CLASS, TYPE, MODULE('CBRC4cls.clw'), LINK('CBRC4cls.clw',_ABCLinkMode_), |
                                DLL(_ABCDllMode_)
!Construct              PROCEDURE(),PROTECTED
!Destruct               PROCEDURE(),PROTECTED


state     group             !int x, y, m[256];
x            long
y            long
m            long,dim(256)  !  string(256)
          end

setup           procedure(string KeyString) !Setup for Crypt by passing key seed
setup           procedure(*string KeyString, long KeyLen=0) !Setup for Crypt by passing key seed
crypt           Procedure(*string Data, long DataLen )      !Does encryption/decryption

StringToHex     PROCEDURE(*STRING In, *STRING OutStr),LONG,PROC  !Returns Output len, Out is 2* In, 0=problem
HexToString     PROCEDURE(*STRING In, *STRING OutStr, <*LONG ErrorPos>),LONG,PROC  !returns outlen 0=problem
                END

_EndOfInclude_

!Carl Notes"
!       If you are going to use this just for yourself you should tweak the Setup a little to get a different initial State
!       I am guessing that would prevent some time of RC4 specific cracking software from breaking you
!       As mentioned below, an easy way would be for setup to call Crypt once and pass it a string of data
!       Another would be to not start K=1, but somewhere else in the key
!       Or read the key in reverse
!
!
!This discussion copied from  from http://www.cr0.net:8040/code/crypto/  Copyright (C) 2001-2003  Christophe Devine
!
!        RC4 is considered cryptographically secure, provided that three hygiene rules are followed:
!          
!        1. The first 512 bytes of RC4's output must be dropped [2] in order to defeat weak-keys attacks [3],
!               and other attacks related to the RC4 key schedule.
!          
!        2. Because RC4 is used as a one-time-pad, one should never use the same key twice.
!                Most protocols use a random IV (initialization vector) appended to the secret key.
!                Then a hash function (say, SHA-1) should be applied, so as to defeat related-keys attacks [4].
!          
!        3. No more than 2^30.6 bytes should be encrypted with RC4 (whatever the key), as it suffers for a 
!               distinguisher attack [5]. To encrypt larger data streams, one should preferably use AES in counter
!               mode (AES-CTR), which acts like a stream cipher.
!          
!        It is strongly recommended to include a message authentication code, for example HMAC [6], using preferably an encrypt-then-mac scheme [7]. 
!        
!        [1] Xiaoyun Wang, Dengguo Feng, Xuejia Lai, Hongbo Yu, "Collisions for Hash Functions MD4, MD5, HAVAL-128 and RIPEMD".
!               http://eprint.iacr.org/2004/199/
!          
!        [2] Ilya Mironov, "(Not So) Random Shuffles of RC4", in Proceedings of CRYPTO 2002.
!               http://citeseer.ist.psu.edu/531224.html
!          
!        [3] Andrew Roos, "A Class of Weak Keys in the RC4 Stream Cipher", in sci.crypt.research, 1995-09-22.
!               http://groups-beta.google.com/group/sci.crypt.research/msg/078aa9249d76eacc?dmode=source
!          
!        [4] Scott Fluhrer, Itsik Mantin, Adi Shamir, "Weaknesses in the Key Scheduling Algorithm of RC4", in Proceedings of SAC 2001.
!               http://citeseer.ist.psu.edu/fluhrer01weaknesses.html
!          
!        [5] Scott Fluhrer, David McGrew, "Statistical Analysis of the Alleged RC4 Keystream Generator", in Proceedings of FSE 2000.
!               http://www.mindspring.com/~dmcgrew/rc4-03.pdf
!          
!        [6] Mihir Bellare, Ran Canetti, Hugo Krawczyk, "Message Authentication Using Hash Functions: the HMAC Construction", in Proceedings of CRYPTO 1996.
!               http://citeseer.ist.psu.edu/bellare96message.html
!          
!        [7] Hugo Krawczyk, "The Order of Encryption and Authentication for Protecting Communications (or: How Secure Is SSL?)", in Proceedings of CRYPTO 2001.
!               http://citeseer.ist.psu.edu/krawczyk01order.html
!
!
!From [3] Andrew Roos, "A Class of Weak Keys...
!        5.  RECOMMENDATIONS   
!         
!        The attacks described in this algorithm result from inadequate "mixing" of key
!        bytes during the generation of the RC4 state table. The following measures
!        could be taken to strengthen cryptosystems based on the RC4 algorithm:
!         
!        (a) After initializing the algorithm, generate and discard a number of bytes.
!            Since the algorithm used to generate bytes also introduces additional
!            non-linear dependencies into the state table, this would make analysis
!            more difficult.
!         
!        (b) In systems which require multiple session keys, ensure that session keys
!            are not linearly related to each other.
!         
!        (c) Avoid using the weak keys described.
!           Carl Note: Below is description, a weak key is when the first two bytes sum to zero i.e. K[0] + K[1] == 0 (mod 256)
!                This allows us to identify a class of weak keys:
!                 
!                C.   Given an RC4 key K[0]..K[N] with K[0] + K[1] == 0 (mod 256), there is a
!                     significant probability that the first byte generated by RC4 will be
!                     K[2] + 3 (mod 256).
!
!Carl summarize:
!I doubt you'll really be doing a stream. But the above guidelines suggest for stringer encryption 
!1. Run some bytes thru Crypt() before doing the stuff you care about. But you must do that on both ends.
!2. Try to use different keys a lot, don't always use the same key


! Ron Rivest homepage has links to much stuff on Crpyto  http://theory.lcs.mit.edu/~rivest/homepage.html

! This page says that MD5 is free to use by anyone  http://www.ietf.org/ietf/IPR/RSA-MD-all

! On Ron's page http://theory.lcs.mit.edu/~rivest/faq.html
! he says that the RC4 algorithm can be used, but the name RC4 is owned by

!Q5. May I use RC2, RC4, RC5, and/or RC6 freely in commercial products? 
!A5. In general, you should contact RSA Security for a definitive answer to these questions.
! For RC4, the "official word" is the following: "The mark RC4 is a registered trademark of RSA Security Inc.
! and may not be used by third parties creating implementations of the algorithm. RSA Security does not hold
! any patents nor does it have any pending applications on the RC4 algorithm. However, RSA Security does not
! represent or warrant that implementations of the algorithm will not infringe the intellectual property rights
! of any third party. Proprietary implementations of the RC4 encryption algorithm are available under license
! from RSA Security Inc. For licensing information, contact: RSA Security Inc. 2955 Campus Drive, Suite 400,
! San Mateo, CA 94403-2507, USA, or http://www.rsasecurity.com." (I don't think this precludes using the term "RC4"
! in scholarly publications, however.) There are no published policies regarding RC2, RC5, or RC6; please contact
! Burt Kaliski (bkaliski@rsasecurity.com) to discuss your situation. 
!





